
/**************************************************************************

Copyright 1996 Richard Mairesse

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appears in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation. No responsibility is assumed for the use
or reliability of this software.

Author:
  Richard Mairesse                                Tel: 0032 81 725009
  Facultes Universitaires Notre-Dame de la Paix   Fax: 0032 81 725023
  Centre de Calcul                                Richard.Mairesse@fundp.ac.be
  rue Grandgagnage 21
  5000 Namur
  Belgium

**************************************************************************/


#include <Xm/PrimitiveP.h>

#include "Joystick.h"

typedef struct _XrmJoystickClassPart {
  int ignore;
} XrmJoystickClassPart;


typedef struct _XrmJoystickClassRec {
  CoreClassPart core_class;
  XmPrimitiveClassPart primitive_class;
  XrmJoystickClassPart Joystick_class;
} XrmJoystickClassRec;


extern XrmJoystickClassRec XrmjoystickClassRec;


typedef struct _XrmJoystickPart {
/* Resources */
  int x_min;               /* XtNxMinimum */
  int x_max;               /* XtNxMaximum */
  int y_min;               /* XtNyMinimum */
  int y_max;               /* XtNyMaximum */
  int x_value;             /* XtNxValue */
  int y_value;             /* XtNyValue */
  Boolean x_proc;          /* XtNxProcessingDirection */
  Boolean y_proc;          /* XtNyProcessingDirection */
  float stick_percentage;  /* XtNstickPercentage */
  Boolean shadow_effect;   /* XtNshadowEffect */
  XtCallbackList select;   /* XtNselect */
/* Private data */
  /* Transformations between coordinate systems */
  float a;       /* x = a*xs + tx */  /* xs = 1/a*x + tpx */
  float d;       /* y = d*ys + ty */  /* ys = 1/d*y + tpy */
  float tx;
  float ty;
  float tpx;
  float tpy;
  /* Some geometric data */
  int x_inf;        /* real values of xmin, xmax, ymin, ymax */
  int x_sup;
  int y_inf;
  int y_sup;
  int radius_base;  /* values of the two radius, fct of XtNstickPercentage */
  int radius_stick;
  int drs;          /* double radius_stick (too many computed) */
  Position x_stick; /* real values of xvalue, yvalue */
  Position y_stick;
  Position cx;      /* position of ((xmax-xmin)/2,(ymax-ymin)/2) */
  Position cy;
  int x_tmp;        /* to retain the ButtonPress in the stick */
  int y_tmp;
  /* Some misc */
  Pixmap cmask;      /* clipping mask */
  Pixmap offscreen; /* offscreen to save the region occupied by the stick */
  int x_offscreen;
  int y_offscreen;
  GC gc;
  GC gcoffscreen;
  GC gcmask;
} XrmJoystickPart;


typedef struct _XrmJoystickRec {
  CorePart core;
  XmPrimitivePart primitive;
  XrmJoystickPart joystick;
} XrmJoystickRec;






